unit Fld_pgm;

interface

uses
  fce, keycode, displayu,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    eServer: TEdit;
    eUser: TEdit;
    ePass: TEdit;
    eMessage: TMemo;
    bConnect: TButton;
    bExit: TButton;
    procedure bConnectClick(Sender: TObject);
    procedure bExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  BUFFER_SIZE = 15000;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.bConnectClick(Sender: TObject);
var
  Code : Integer;
  Text : String;
  ServerPtr  : PChar;
  UserPtr : PChar;
  Passptr : PChar;
  TempPtr : PChar;
  BufferPtr : PChar;
  BufferString : String;
  Line : Integer;
  NbrLines : Integer;
  Field : Integer;
begin
  {check FTP parameters}
  if Length(eServer.Text) < 1 then
    begin
      DisplayLine(eMessage, 'Missing server name');
      exit
    end;
  if Length(eUser.Text) < 1 then
    begin
      DisplayLine(eMessage, 'Missing user name');
      exit
    end;
  if Length(ePass.Text) < 1 then
    begin
      DisplayLine(eMessage, 'Missing password name');
      exit
    end;
  {attach FCE}
  Code := fceAttach(1, FCE_KEY_CODE);
  if Code < 0 then
    begin
      Text := Format('Cannot attach FCE (error %d)',[Code]);
      DisplayLine(eMessage, Text);
      exit;
    end;
  {set log file}
  GetMem(TempPtr,32);
  StrPCopy(TempPtr, 'field.log');
  Code := fceSetString(0, FCE_SET_LOG_FILE, TempPtr);
  if Code < 0 then DisplayError(eMessage,Code);
  FreeMem(TempPtr, 32);
  DisplayLine(eMessage,'Connecting');
  {connect to FTP server}
  GetMem(ServerPtr, 64); StrPCopy(ServerPtr, eServer.Text);
  GetMem(UserPtr, 64); StrPCopy(UserPtr, eUser.Text);
  GetMem(PassPtr, 64); StrPCopy(PassPtr, ePass.Text);
  Code := fceConnect(0, ServerPtr, UserPtr, PassPtr);
  FreeMem(ServerPtr,64); FreeMem(UserPtr,64); FreeMem(PassPtr,64);
  if Code >= 0 then
    begin
      {connect; get IP address of server}
      GetMem(TempPtr,64);
      Code := fceGetString(0, FCE_GET_SERVER_IP, TempPtr, 64);
      if Code < 0 then DisplayError(eMessage, Code)
      else
        begin
          Text := StrPas(TempPtr);
          {report to user}
          DisplayString(eMessage,'Connected to ');
          DisplayLine(eMessage, Text);
        end;
      FreeMem(TempPtr, 64);
      {get listing}
      GetMem(BufferPtr, BUFFER_SIZE);
      SCREEN.Cursor := crHourGlass;
      Code := fceGetList(0,FCE_FULL_LIST,BufferPtr,BUFFER_SIZE);
      SCREEN.Cursor := crDefault;
      if Code < 0 then
        begin
          DisplayError(eMessage, Code);
          FreeMem(BufferPtr, BUFFER_SIZE);
          exit
        end;
      if Code > 0 then
        begin
          {got file listing}
          BufferPtr[Code] := chr(0);
          NbrLines := fceGetString(0, FCE_GET_LINE_COUNT, BufferPtr, BUFFER_SIZE);
          Text := Format('%d lines',[NbrLines]);
          DisplayLine(eMessage, Text);
          GetMem(TempPtr,128);
          {look at each line in listing}
          for Line := 1 To NbrLines do
            begin
              Text := Format('*** Line %d ***',[Line]);
              DisplayLine(eMessage, Text);
              {display all fields}
              Field := 1;
              Repeat
                {extract field from line}
                Code := fceExtract(BufferPtr, Line, Field, TempPtr, 128);
                If Code > 0 Then
                  begin
                    {display field}
                    Text := Format('Field = %d, Text = %s',
                            [Field,StrPas(TempPtr)] );
                    DisplayLine(eMessage, Text);
                    Inc(Field);
                  end;
              Until Code <= 0;
            end;
          FreeMem(TempPtr, 128);
        end;
      DisplayLine(eMessage,'[END]');
      FreeMem(BufferPtr, BUFFER_SIZE);
      {close connection to server}
      Code := fceClose(0);
      if Code < 0 then DisplayError(eMessage, Code);
    end
  else
    begin
      {connect failed}
      DisplayError(eMessage,Code)
    end;
  fceRelease
end;

procedure TForm1.bExitClick(Sender: TObject);
begin
  {Exit}
  Application.Terminate
end;

end.
