unit Get_pgm;

interface

uses
  fce, keycode, displayu,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus;

type
  TGETPRO = class(TForm)
    MainMenu1: TMainMenu;
    mPushMe: TMenuItem;
    mDownload: TMenuItem;
    mExit: TMenuItem;
    eMessage: TMemo;
    procedure mExitClick(Sender: TObject);
    procedure mDownloadClick(Sender: TObject);
    procedure mPushMeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GETPRO: TGETPRO;

implementation

{$R *.DFM}

procedure TGETPRO.mExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TGETPRO.mDownloadClick(Sender: TObject);
var
  Code : Integer;
  Text : String;
  ServerPtr  : PChar;
  UserPtr : PChar;
  Passptr : PChar;
  DirPtr : PChar;
  FilePtr : PChar;
  TempPtr : PChar;
begin
  {attach FCE}
  Code := fceAttach(1, FCE_KEY_CODE);
  if Code < 0 then
    begin
      Text := Format('Cannot attach FCE (error %d)',[Code]);
      DisplayLine(GETPRO.eMessage, Text);
      exit;
    end;
  {set log file}
  GetMem(TempPtr,32);
  StrPCopy(TempPtr, 'get_pgm.log');
  Code := fceSetString(0, FCE_SET_LOG_FILE, TempPtr);
  if Code < 0 then DisplayError(GETPRO.eMessage,Code);
  FreeMem(TempPtr, 32);
  (* connect to FTP server *)
  GetMem(ServerPtr, 64); StrPCopy(ServerPtr, 'ftp.marshallsoft.com');
  GetMem(UserPtr, 64); StrPCopy(UserPtr, 'anonymous');
  GetMem(PassPtr, 64); StrPCopy(PassPtr, 'msc@traveller.com');
  Code := fceConnect(0, ServerPtr, UserPtr, PassPtr);
  FreeMem(ServerPtr,64); FreeMem(UserPtr,64); FreeMem(PassPtr,64);
  if Code >= 0 then
    begin
      {connect; get IP address of server}
      GetMem(TempPtr,64);
      Code := fceGetString(0, FCE_GET_SERVER_IP, TempPtr, 64);
	  if Code < 0 then DisplayError(eMessage, Code)
      else 
	    begin
		  Text := StrPas(TempPtr);
		  {report to user}
		  DisplayString(GETPRO.eMessage,'Connected to');
          DisplayLine(GETPRO.eMessage, Text);
		end;
      FreeMem(TempPtr, 64);
      {set server directory}
      GetMem(DirPtr, 64); StrPCopy(DirPtr, 'pub/other');
      Code := fceSetServerDir(0, DirPtr);
      FreeMem(DirPtr, 64);
      if Code < 0 then DisplayError(GETPRO.eMessage,Code)
      else
        begin
          DisplayLine(GETPRO.eMessage,'Downloading file "products.txt"');
          GetMem(FilePtr, 64); StrPCopy(Fileptr,'products.txt');
          Code := fceGetFile(0, FilePtr);
          FreeMem(Fileptr, 64);
          if Code < 0 then DisplayError(GETPRO.eMessage,Code)
          else
            begin
              DisplayLine(GETPRO.eMessage,'File "products.txt" downloaded.');
              DisplayLine(GETPRO.eMessage,'Press "Exit" above to quit.')
            end
        end;
      {close connection to server}
      Code := fceClose(0);
      if Code < 0 then DisplayError(eMessage, Code);		
    end
  else
    begin
      {connect failed}
      DisplayError(GETPRO.eMessage,Code)
    end;
  fceRelease
end;

procedure TGETPRO.mPushMeClick(Sender: TObject);
begin
  DisplayLine(GETPRO.eMessage,'This applications connects to the MarshallSoft FTP site');
  DisplayLine(GETPRO.eMessage,'at ftp://ftp.marshallsoft.com and downloads the file');
  DisplayLine(GETPRO.eMessage,'products.txt from pub/other')
end;

end.
