unit List_pgm;

interface

uses
  fce, keycode, displayu,
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TList = class(TForm)
    eServer: TEdit;
    eUser: TEdit;
    ePass: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    eMessage: TMemo;
    bConnect: TButton;
    bExit: TButton;
    procedure bConnectClick(Sender: TObject);
    procedure bExitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
   BUFFER_SIZE = 15000;

var
  List: TList;

implementation

{$R *.DFM}

procedure TList.bConnectClick(Sender: TObject);
var
  Code : Integer;
  Text : String;
  ServerPtr  : PChar;
  UserPtr : PChar;
  Passptr : PChar;
  TempPtr : PChar;
  BufferPtr : PChar;
  BufferString : String;
begin
  {check FTP parameters}
  if Length(eServer.Text) < 1 then
    begin
      DisplayLine(eMessage, 'Missing server name');
      exit
    end;
  if Length(eUser.Text) < 1 then
    begin
      DisplayLine(eMessage, 'Missing user name');
      exit
    end;
  if Length(ePass.Text) < 1 then
    begin
      DisplayLine(eMessage, 'Missing password name');
      exit
    end;
  {attach FCE}
  Code := fceAttach(1, FCE_KEY_CODE);
  if Code < 0 then
    begin
      Text := Format('Cannot attach FCE (error %d)',[Code]);
      DisplayLine(eMessage, Text);
      exit;
    end;
  {set log file}
  GetMem(TempPtr,32);
  StrPCopy(TempPtr, 'list.log');
  Code := fceSetString(0, FCE_SET_LOG_FILE, TempPtr);
  if Code < 0 then DisplayError(eMessage,Code);
  FreeMem(TempPtr, 32);
  (* connect to FTP server *)
  GetMem(ServerPtr, 64); StrPCopy(ServerPtr, eServer.Text);
  GetMem(UserPtr, 64); StrPCopy(UserPtr, eUser.Text);
  GetMem(PassPtr, 64); StrPCopy(PassPtr, ePass.Text);
  Code := fceConnect(0, ServerPtr, UserPtr, PassPtr);
  FreeMem(ServerPtr,64); FreeMem(UserPtr,64); FreeMem(PassPtr,64);
  if Code >= 0 then
    begin
      {connect; get IP address of server}
      GetMem(TempPtr,64);
      Code := fceGetString(0, FCE_GET_SERVER_IP, TempPtr, 64);
      if Code < 0 then DisplayError(eMessage, Code)
      else
        begin
          Text := StrPas(TempPtr);
          {report to user}
          DisplayString(eMessage,'Connected to ');
          DisplayLine(eMessage, Text);
        end;
      FreeMem(TempPtr, 64);
      {get listing}
      GetMem(BufferPtr, BUFFER_SIZE);
      SCREEN.Cursor := crHourGlass;
      Code := fceGetList(0,FCE_FULL_LIST,BufferPtr,BUFFER_SIZE);
      SCREEN.Cursor := crDefault;
      if Code < 0 then
        begin
          DisplayError(eMessage, Code);
          FreeMem(BufferPtr, BUFFER_SIZE);
          exit
        end;
      if Code > 0 then
        begin
          BufferPtr[Code] := chr(0);
          {display contents of BufferPtr}
          DisplayPChar(eMessage, BufferPtr);
          Code := fceGetString(0, FCE_GET_LINE_COUNT, BufferPtr, BUFFER_SIZE);
          Text := Format('%d lines.',[Code]);
          DisplayLine(eMessage, Text);
        end;
      DisplayLine(eMessage,'[END]');
      FreeMem(BufferPtr, BUFFER_SIZE);
      {close connection to server}
      Code := fceClose(0);
      if Code < 0 then DisplayError(eMessage, Code);
    end
  else
    begin
      {connect failed}
      DisplayError(eMessage,Code)
    end;
  fceRelease
end;

procedure TList.bExitClick(Sender: TObject);
begin
  {exit}
  Application.Terminate
end;

end.
